"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FormGroupCheckbox = FormGroupCheckbox;
exports.FormGroupInput = FormGroupInput;
exports.FormGroupRadio = FormGroupRadio;
exports.FormGroupSelect = FormGroupSelect;
exports.FormGroupSwitch = FormGroupSwitch;
exports.FormGroupTextarea = FormGroupTextarea;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _FormCheckbox = require("./FormCheckbox");

var _FormInput = require("./FormInput");

var _FormLabel = require("./FormLabel");

var _FormRadio = require("./FormRadio");

var _FormSelect = require("./FormSelect");

var _FormSwitch = require("./FormSwitch");

var _FormTextarea = require("./FormTextarea");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function FormGroup(_ref) {
  var children = _ref.children,
      props = _objectWithoutProperties(_ref, ["children"]);

  return _react["default"].createElement("div", {
    className: "form-group"
  }, _react["default"].createElement(_FormLabel.FormLabel, props), children);
}

FormGroup.propTypes = {
  children: _propTypes["default"].element
};

function FormGroupCheckbox(props) {
  return _react["default"].createElement(FormGroup, props, _react["default"].createElement(_FormCheckbox.FormCheckbox, props));
}

function FormGroupInput(props) {
  return _react["default"].createElement(FormGroup, props, _react["default"].createElement(_FormInput.FormInput, props));
}

function FormGroupRadio(_ref2) {
  var options = _ref2.options,
      id = _ref2.id,
      props = _objectWithoutProperties(_ref2, ["options", "id"]);

  return _react["default"].createElement(FormGroup, props, _react["default"].createElement("div", null, options.map(function (option, index) {
    return _react["default"].createElement(_FormRadio.FormRadio, _extends({
      key: index
    }, props, {
      checkedValue: option.value,
      valueLabel: option.label,
      id: "".concat(id, "-").concat(index)
    }));
  })));
}

FormGroupRadio.defaultProps = {
  inline: true
};
FormGroupRadio.propTypes = {
  id: _propTypes["default"].string,
  options: _propTypes["default"].arrayOf(_propTypes["default"].object),
  inline: _propTypes["default"].bool
};

function FormGroupSelect(props) {
  return _react["default"].createElement(FormGroup, props, _react["default"].createElement(_FormSelect.FormSelect, props));
}

function FormGroupSwitch(props) {
  return _react["default"].createElement(FormGroup, props, _react["default"].createElement(_FormSwitch.FormSwitch, props));
}

function FormGroupTextarea(props) {
  return _react["default"].createElement(FormGroup, props, _react["default"].createElement(_FormTextarea.FormTextarea, props));
}