"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FormSelect = FormSelect;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _formHelpers = require("./form-helpers");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function FormSelect(_ref) {
  var id = _ref.id,
      name = _ref.name,
      options = _ref.options,
      required = _ref.required,
      placeholder = _ref.placeholder;
  var formState = (0, _react.useContext)(_formHelpers.FormContext);
  return _react["default"].createElement("select", _extends({
    required: required,
    name: name,
    id: id
  }, {
    className: "form-control",
    onChange: _formHelpers.handleInputChange.bind(null, formState),
    value: formState.getValue(name) || ''
  }), _react["default"].createElement("option", {
    value: ""
  }, placeholder), renderOptions(options, formState.getFormData()));
}

FormSelect.propTypes = {
  id: _propTypes["default"].string,
  options: _propTypes["default"].oneOfType([_propTypes["default"].func, _propTypes["default"].arrayOf(_propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].object]))]),
  name: _propTypes["default"].string.isRequired,
  placeholder: _propTypes["default"].string,
  required: _propTypes["default"].any
};

function renderOptions(options, formData) {
  var _options = typeof options === 'function' ? options(formData) : options;

  if (!Array.isArray(_options)) {
    throw new Error('Select Options should be an array');
  }

  return _options.map(function (option, index) {
    var value, label;

    if (typeof option === 'string') {
      value = label = option;
    } else {
      value = option.value;
      label = option.label;
    }

    return _react["default"].createElement("option", {
      key: index,
      value: value
    }, label);
  });
}