"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Pagination = Pagination;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function Pagination(_ref) {
  var actualPage = _ref.actualPage,
      ariaLabel = _ref.ariaLabel,
      firstLabel = _ref.firstLabel,
      lastLabel = _ref.lastLabel,
      lastPage = _ref.lastPage,
      maxPageWindow = _ref.maxPageWindow,
      nextLabel = _ref.nextLabel,
      onSelect = _ref.onSelect,
      previousLabel = _ref.previousLabel;
  var pageWindow = Math.min(maxPageWindow, lastPage);
  var centerOfPageWindow = Math.max(Math.floor(pageWindow / 2), 2);
  var lastStartPage = Math.max(lastPage - pageWindow + 1, 1);
  var startPage = Math.max(Math.min(actualPage - centerOfPageWindow, lastStartPage), 1);
  var showPreviousNavigation = startPage > 1;
  var pages = Array.from({
    length: pageWindow
  }, function (v, i) {
    return startPage + i;
  });

  var select = function select(page) {
    return function (e) {
      e.preventDefault();
      e.stopPropagation();
      onSelect(page);
    };
  };

  return _react["default"].createElement("nav", {
    "aria-label": ariaLabel
  }, _react["default"].createElement("ul", {
    className: "pagination"
  }, showPreviousNavigation && _react["default"].createElement(_react["default"].Fragment, null, _react["default"].createElement("li", {
    className: "page-item"
  }, _react["default"].createElement("a", {
    className: "page-link",
    href: "",
    onClick: select(1),
    "aria-label": firstLabel
  }, _react["default"].createElement("span", {
    "aria-hidden": "true"
  }, "\xAB"), _react["default"].createElement("span", {
    className: "sr-only"
  }, firstLabel))), _react["default"].createElement("li", {
    className: "page-item"
  }, _react["default"].createElement("a", {
    className: "page-link",
    href: "",
    onClick: select(actualPage - 1),
    "aria-label": previousLabel
  }, _react["default"].createElement("span", {
    "aria-hidden": "true"
  }, "\u2039"), _react["default"].createElement("span", {
    className: "sr-only"
  }, previousLabel)))), pages.map(function (page) {
    return _react["default"].createElement("li", {
      key: "pages-".concat(page),
      className: "page-item".concat(actualPage === page ? ' active' : '')
    }, _react["default"].createElement("a", {
      className: "page-link",
      href: "",
      onClick: select(page)
    }, page));
  }), startPage < lastStartPage && _react["default"].createElement(_react["default"].Fragment, null, _react["default"].createElement("li", {
    className: "page-item"
  }, _react["default"].createElement("a", {
    className: "page-link",
    href: "",
    onClick: select(actualPage + 1),
    "aria-label": nextLabel
  }, _react["default"].createElement("span", {
    "aria-hidden": "true"
  }, "\u203A"), _react["default"].createElement("span", {
    className: "sr-only"
  }, nextLabel))), _react["default"].createElement("li", {
    className: "page-item"
  }, _react["default"].createElement("a", {
    className: "page-link",
    href: "",
    onClick: select(lastPage),
    "aria-label": lastLabel
  }, _react["default"].createElement("span", {
    "aria-hidden": "true"
  }, "\xBB"), _react["default"].createElement("span", {
    className: "sr-only"
  }, lastLabel))))));
}

Pagination.defaultProps = {
  actualPage: 1,
  ariaLabel: 'Page navigation',
  firstLabel: 'First',
  lastLabel: 'Last',
  maxPageWindow: 5,
  nextLabel: 'Next',
  previousLabel: 'Previous'
};
Pagination.propTypes = {
  actualPage: _propTypes["default"].number,
  ariaLabel: _propTypes["default"].string,
  firstLabel: _propTypes["default"].string,
  lastLabel: _propTypes["default"].string,
  lastPage: _propTypes["default"].number,
  maxPageWindow: _propTypes["default"].number,
  nextLabel: _propTypes["default"].string,
  onSelect: _propTypes["default"].func.isRequired,
  previousLabel: _propTypes["default"].string
};