"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Table = Table;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _TableHead = require("./TableHead");

var _TableBody = require("./TableBody");

var _tableHelpers = require("./table-helpers");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function Table(_ref) {
  var docs = _ref.docs,
      columns = _ref.columns,
      striped = _ref.striped,
      bordered = _ref.bordered,
      hover = _ref.hover,
      small = _ref.small,
      dark = _ref.dark,
      rowClass = _ref.rowClass,
      caption = _ref.caption,
      actions = _ref.actions,
      actionLabel = _ref.actionLabel;
  var normalizedColumns = (0, _tableHelpers.normalizeColumns)(columns);
  var tableClasses = ['table', striped && 'table-striped', bordered && 'table-bordered', hover && 'table-hover', small && 'table-sm', dark && 'table-dark'].join(' ');
  return _react["default"].createElement("div", {
    className: "table-responsive"
  }, _react["default"].createElement("table", {
    className: tableClasses
  }, caption && _react["default"].createElement("caption", null, caption), _react["default"].createElement(_TableHead.TableHead, _extends({
    actions: actions,
    actionLabel: actionLabel
  }, {
    columns: normalizedColumns
  })), _react["default"].createElement(_TableBody.TableBody, _extends({
    docs: docs,
    rowClass: rowClass,
    actions: actions
  }, {
    columns: normalizedColumns
  }))));
}

Table.defaultProps = {
  striped: true,
  bordered: false,
  hover: true,
  small: true,
  dark: false,
  actionLabel: 'Actions',
  rowClass: function rowClass() {
    return '';
  }
};
Table.propTypes = {
  actions: _propTypes["default"].arrayOf(_propTypes["default"].object),
  columns: _propTypes["default"].arrayOf(_propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].object])),
  docs: _propTypes["default"].arrayOf(_propTypes["default"].object),
  rowClass: _propTypes["default"].func,
  striped: _propTypes["default"].bool,
  bordered: _propTypes["default"].bool,
  hover: _propTypes["default"].bool,
  small: _propTypes["default"].bool,
  dark: _propTypes["default"].bool,
  caption: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].element]),
  actionLabel: _propTypes["default"].string
};