"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TableHead = TableHead;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _tableHelpers = require("./table-helpers");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function TableHead(_ref) {
  var columns = _ref.columns,
      actions = _ref.actions,
      actionLabel = _ref.actionLabel;
  return _react["default"].createElement("thead", null, _react["default"].createElement("tr", null, columns.map(function (column, columnIndex) {
    return _react["default"].createElement("th", {
      key: columnIndex,
      className: (0, _tableHelpers.getColumnClass)(column)
    }, column.label);
  }), actions && _react["default"].createElement("th", {
    className: "text-center"
  }, actionLabel)));
}

TableHead.propTypes = {
  actionLabel: _propTypes["default"].string,
  actions: _propTypes["default"].arrayOf(_propTypes["default"].object),
  columns: _propTypes["default"].arrayOf(_propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].object]))
};