"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TabHeader = TabHeader;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function TabHeader(_ref) {
  var index = _ref.index,
      isActive = _ref.isActive,
      title = _ref.title,
      onSelect = _ref.onSelect;
  return _react["default"].createElement("li", {
    className: "nav-item"
  }, _react["default"].createElement("a", {
    className: "nav-link ".concat(isActive ? 'active' : '') // id="home-tab"
    ,
    "data-toggle": "tab",
    href: "" // href="#home"
    ,
    onClick: safeClick(onSelect, index),
    role: "tab" // aria-controls="home"
    ,
    "aria-selected": isActive
  }, title));
}

TabHeader.propTypes = {
  index: _propTypes["default"].number,
  isActive: _propTypes["default"].bool,
  title: _propTypes["default"].string,
  onSelect: _propTypes["default"].func
};

function safeClick(callback, index) {
  return function (e) {
    e.stopPropagation();
    e.preventDefault();
    callback(index);
  };
}