"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Tabs = Tabs;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _TabHeader = require("./TabHeader");

var _TabContent = require("./TabContent");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function Tabs(_ref) {
  var vertical = _ref.vertical,
      tabs = _ref.tabs,
      activeTab = _ref.activeTab,
      onlyRenderActiveTab = _ref.onlyRenderActiveTab,
      bordered = _ref.bordered,
      onSelect = _ref.onSelect;

  if (activeTab >= tabs.length) {
    console.warn('Invalid tab selected:', activeTab);
  }

  return _react["default"].createElement("div", {
    className: "custom-tabs-container ".concat(vertical ? 'd-flex' : '')
  }, _react["default"].createElement("div", {
    className: "tabs-navigation"
  }, _react["default"].createElement("ul", {
    className: "nav ".concat(vertical ? 'nav-pills flex-column' : 'nav-tabs'),
    id: "myTab",
    role: "tablist"
  }, tabs.map(function (tab, tabIndex) {
    return _react["default"].createElement(_TabHeader.TabHeader, {
      key: tabIndex,
      index: tabIndex,
      isActive: tabIndex === activeTab,
      title: tab.title,
      onSelect: onSelect
    });
  }))), _react["default"].createElement("div", {
    className: "tab-content ".concat(vertical ? 'flex-fill ml-3' : "".concat(bordered ? 'border-left border-right border-bottom p-2' : 'py-2')) // id="myTabContent"

  }, onlyRenderActiveTab ? _react["default"].createElement(_TabContent.TabContent, {
    isActive: true,
    content: tabs[activeTab] && tabs[activeTab].content
  }) : tabs.map(function (tab, tabIndex) {
    return _react["default"].createElement(_TabContent.TabContent, {
      key: tabIndex,
      isActive: tabIndex === activeTab,
      content: tab.content
    });
  })));
}

Tabs.defaultProps = {
  vertical: false,
  bordered: false,
  activeTab: 0,
  onlyRenderActiveTab: false,
  onSelect: function onSelect() {}
};
Tabs.propTypes = {
  vertical: _propTypes["default"].bool,
  tabs: _propTypes["default"].arrayOf(_propTypes["default"].object),
  activeTab: _propTypes["default"].number,
  onlyRenderActiveTab: _propTypes["default"].bool,
  bordered: _propTypes["default"].bool,
  onSelect: _propTypes["default"].func
};